"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const yargs_1 = __importDefault(require("yargs"));
const compile_1 = __importDefault(require("./compile"));
yargs_1.default
    .scriptName('yml-schema')
    .command('compile <outputDir> [inputFiles..]', 'comile files', (builder) => {
    builder
        .option('outputDir', {
        type: 'string',
    })
        .option('inputFiles', {
        type: 'array',
    });
}, function (argv) {
    const inputFiles = argv.inputFiles;
    const outputDir = argv.outputDir;
    Promise.all(inputFiles.map(async (filepath) => {
        const filename = path_1.default.basename(filepath).replace(/\.ya?ml$/, '.json');
        const outfile = path_1.default.resolve(outputDir, filename);
        fs_1.default.mkdirSync(path_1.default.dirname(outfile), { recursive: true });
        fs_1.default.writeFileSync(outfile, await compile_1.default(path_1.default.resolve(filepath)));
        process.stdout.write(`Successfully compiled ${filepath} to ${path_1.default.relative('.', outfile)}\n`);
    }))
        .then(() => {
        process.stdout.write(`Successfully compiled ${inputFiles.length} files\n`);
    })
        .catch((err) => {
        process.stderr.write(`Something went wrong: ${err.message}`);
    });
})
    .help()
    .demandCommand()
    .demandOption('outputDir').argv;
